Unit xDos;
interface
uses Objects;

Type
 TxBufStream=Object(TBufStream)
 procedure Seek(Pos:Longint); virtual;
 procedure iSeek(iPos:Longint); virtual;
 end;

 procedure Delete(FileName:FNameStr; var Info:integer);
 procedure Rename(OldName,NewName:FNameStr; var Info:integer);

 {  筮 ,   ⠪ ᯮ筥 }
 function GetDay:byte;
 function GetMonth:byte;
 function GetYear:word;

implementation
uses Dos;
var regs:registers;

procedure TxBufStream.iSeek(iPos:Longint);
var LR:LongRec absolute iPos;
Begin
 if Status=stOk then
   With regs do
    begin
      BX:= Handle;
      CX:= LR.Hi;
      DX:= LR.Lo;
      AL:= $01;
      AH:= $42;
      MsDos( regs );
      Status:=(flags and $0001);
      if Status =1 then
       begin
        Status:=AX;
        AH:=$59;
        BX:=$00;
        MsDos( regs );
        Error(Status, AX);
       end
      else
    end;
End;

procedure TxBufStream.Seek(Pos:longint);
Begin
 if ((BufPtr-GetPos+Pos) < 1) OR ((BufPtr+Pos-GetPos) > BufEnd)
 then inherited Seek(Pos)
 else BufPtr:=BufPtr+Pos-GetPos;

 {       䥪⨢  ࠡ⠥ ४⭮ }

 { if (BufPtr-GetPos+Pos) < 1 then
    if (Pos-BufSize) < 0 then
      begin
       inherited Seek(0);
       BufPtr:=Pos;
      end
    else
      begin
       inherited Seek(Pos-BufSize);
       BufPtr:=BufSize;
      end
  else
    if (BufPtr+Pos-GetPos) > BufEnd then inherited Seek(Pos)
    else BufPtr:=BufPtr+Pos-GetPos;}
End;

procedure Delete(FileName:FNameStr; var Info:integer);
BEGIN
   FileName:=Concat(FileName,#0);
   with regs do
     begin
       flags:=( flags and  $0000 );
       DS := Seg(FileName[1]);
       DX := Ofs(FileName[1]);
       AH := $41;
       MsDos( regs );
       Info:=(flags and $0001);
       if Info = 1 then Info:=AX;
     end;
 end;

procedure Rename(OldName,NewName:FNameStr; var Info:integer);
BEGIN
   OldName:=Concat(OldName,#0);
   NewName:=Concat(NewName,#0);
   with regs do
     begin
       flags:=( flags and  $0000 );
       DS := Seg(OldName[1]);
       DX := Ofs(OldName[1]);
       ES := Seg(NewName[1]);
       DI := Ofs(NewName[1]);
       AH := $56;
       MsDos( regs );
       info:=(flags and $0001);
       if info = 1 then Info:=AX;
     end;
 end;

 function GetDay:byte; assembler;
 asm
 mov ah,2ah
 int 21h
 mov al,DL
 end;

 function GetMonth:byte; assembler;
 asm
 mov ah,2ah
 int 21h
 mov al,DH
 end;

 function GetYear:word; assembler;
 asm
 mov ah,2ah
 int 21h
 mov AX,CX
 end;

END.

